Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 90096)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 90101)
@@ -86,4 +86,5 @@
     switch (mode())
     {
+        case WizardMode_Expert:
         case WizardMode_Basic:
         {
@@ -95,9 +96,9 @@
             break;
         }
-        case WizardMode_Expert:
-        {
-            // addPage(new UIWizardNewCloudVMPageExpert(m_fFullWizard));
-            break;
-        }
+        // case WizardMode_Expert:
+        // {
+        //     // addPage(new UIWizardNewCloudVMPageExpert(m_fFullWizard));
+        //     break;
+        // }
         default:
         {
@@ -568,9 +569,9 @@
 void UIWizardNewVM::setFieldsFromDefaultUnttendedInstallData()
 {
-    // setField("userName", m_unattendedInstallData.m_strUserName);
-    // setField("password", m_unattendedInstallData.m_strPassword);
-    // setField("hostname", m_unattendedInstallData.m_strHostname);
-    // setField("installGuestAdditions", m_unattendedInstallData.m_fInstallGuestAdditions);
-    // setField("guestAdditionsISOPath", m_unattendedInstallData.m_strGuestAdditionsISOPath);
+    m_strUserName = m_unattendedInstallData.m_strUserName;
+    m_strPassword = m_unattendedInstallData.m_strPassword;
+    m_strHostname = m_unattendedInstallData.m_strHostname;
+    m_fInstallGuestAdditions = m_unattendedInstallData.m_fInstallGuestAdditions;
+    m_strGuestAdditionsISOPath = m_unattendedInstallData.m_strGuestAdditionsISOPath;
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp	(revision 90096)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp	(revision 90101)
@@ -284,23 +284,4 @@
 }
 
-// QString UIWizardNewVMNameOSTypePage::machineBaseName() const
-// {
-//     return m_strMachineBaseName;
-// }
-
-// void UIWizardNewVMNameOSTypePage::setMachineBaseName(const QString &strMachineBaseName)
-// {
-//     m_strMachineBaseName = strMachineBaseName;
-// }
-
-
-// QString UIWizardNewVMNameOSTypePage::ISOFilePath() const
-// {
-//     if (!m_pNameAndSystemEditor)
-//         return QString();
-//     return m_pNameAndSystemEditor->image();
-// }
-
-
 void UIWizardNewVMNameOSTypePage::determineOSType(const QString &strISOPath, UIWizardNewVM *pWizard)
 {
@@ -359,15 +340,4 @@
 
     createConnections();
-    // /* Register fields: */
-    // registerField("name*", m_pNameAndSystemEditor, "name", SIGNAL(sigNameChanged(const QString &)));
-    // registerField("type", m_pNameAndSystemEditor, "type", SIGNAL(sigOsTypeChanged()));
-    // registerField("machineFilePath", this, "machineFilePath");
-    // registerField("machineFolder", this, "machineFolder");
-    // registerField("machineBaseName", this, "machineBaseName");
-    // registerField("guestOSFamiyId", this, "guestOSFamiyId");
-    // registerField("startHeadless", this, "startHeadless");
-    // registerField("ISOFilePath", this, "ISOFilePath");
-    // registerField("isUnattendedEnabled", this, "isUnattendedEnabled");
-    // registerField("detectedOSTypeId", this, "detectedOSTypeId");
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90096)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90101)
@@ -153,4 +153,16 @@
     disableEnableGAWidgets(m_pGAInstallationISOContainer ? m_pGAInstallationISOContainer->isChecked() : false);
     retranslateUi();
+
+    /* Initialize user/password if they are not modified by the user: */
+    if (m_pUserNamePasswordEditor)
+    {
+        m_pUserNamePasswordEditor->blockSignals(true);
+        if (!m_userModifiedParameters.contains("UserName"))
+        {
+
+        }
+        m_pUserNamePasswordEditor->blockSignals(false);
+
+    }
 }
 
@@ -198,4 +210,5 @@
 {
     newVMWizardPropertySet(UserName, strUserName);
+    m_userModifiedParameters << "UserName";
     emit completeChanged();
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h	(revision 90096)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h	(revision 90101)
@@ -101,5 +101,5 @@
         QLabel     *m_pProductKeyLabel;
     /** @} */
-
+    QSet<QString> m_userModifiedParameters;
 };
 