Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 90157)
@@ -2655,5 +2655,5 @@
     comUnattendedInstaller.SetPassword(unattendedData.m_strPassword);
     checkUnattendedInstallError(comUnattendedInstaller);
-    comUnattendedInstaller.SetHostname(unattendedData.m_strHostnameDomain);
+    comUnattendedInstaller.SetHostname(unattendedData.m_strHostnameDomainName);
     checkUnattendedInstallError(comUnattendedInstaller);
     comUnattendedInstaller.SetProductKey(unattendedData.m_strProductKey);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp	(revision 90157)
@@ -38,7 +38,7 @@
     : QIWithRetranslateUI<QWidget>(pParent)
     , m_pHostnameLineEdit(0)
-    , m_pDomainLineEdit(0)
+    , m_pDomainNameLineEdit(0)
     , m_pHostnameLabel(0)
-    , m_pDomainLabel(0)
+    , m_pDomainNameLabel(0)
 {
     prepare();
@@ -55,5 +55,5 @@
 {
     return m_pHostnameLineEdit && m_pHostnameLineEdit->hasAcceptableInput() &&
-        m_pDomainLineEdit && m_pDomainLineEdit->hasAcceptableInput();
+        m_pDomainNameLineEdit && m_pDomainNameLineEdit->hasAcceptableInput();
 }
 
@@ -64,21 +64,21 @@
 }
 
-QString UIHostnameDomainNameEditor::domain() const
+QString UIHostnameDomainNameEditor::domainName() const
 {
-    if (m_pDomainLineEdit)
-        return m_pDomainLineEdit->text();
+    if (m_pDomainNameLineEdit)
+        return m_pDomainNameLineEdit->text();
     return QString();
 }
 
-void UIHostnameDomainNameEditor::setDomain(const QString &strDomain)
+void UIHostnameDomainNameEditor::setDomainName(const QString &strDomain)
 {
-    if (m_pDomainLineEdit)
-        m_pDomainLineEdit->setText(strDomain);
+    if (m_pDomainNameLineEdit)
+        m_pDomainNameLineEdit->setText(strDomain);
 }
 
-QString UIHostnameDomainNameEditor::hostnameDomain() const
+QString UIHostnameDomainNameEditor::hostnameDomainName() const
 {
-    if (m_pHostnameLineEdit && m_pDomainLineEdit)
-        return QString("%1.%2").arg(m_pHostnameLineEdit->text()).arg(m_pDomainLineEdit->text());
+    if (m_pHostnameLineEdit && m_pDomainNameLineEdit)
+        return QString("%1.%2").arg(m_pHostnameLineEdit->text()).arg(m_pDomainNameLineEdit->text());
     return QString();
 }
@@ -95,10 +95,10 @@
     if (m_pHostnameLineEdit)
         m_pHostnameLineEdit->setToolTip(strHostnameTooltip);
-    if (m_pDomainLabel)
+    if (m_pDomainNameLabel)
     {
-        m_pDomainLabel->setText(tr("&Domain"));
-        m_pDomainLabel->setToolTip(strDomainTooltip);
+        m_pDomainNameLabel->setText(tr("&Domain"));
+        m_pDomainNameLabel->setToolTip(strDomainTooltip);
     }
-    m_pDomainLineEdit->setToolTip(strDomainTooltip);
+    m_pDomainNameLineEdit->setToolTip(strDomainTooltip);
 }
 
@@ -140,9 +140,9 @@
     int iRow = 0;
     addLineEdit(iRow, m_pHostnameLabel, m_pHostnameLineEdit, pMainLayout);
-    addLineEdit(iRow, m_pDomainLabel, m_pDomainLineEdit, pMainLayout);
+    addLineEdit(iRow, m_pDomainNameLabel, m_pDomainNameLineEdit, pMainLayout);
 
     connect(m_pHostnameLineEdit, &QILineEdit::textChanged,
             this, &UIHostnameDomainNameEditor::sltHostnameChanged);
-    connect(m_pDomainLineEdit, &QILineEdit::textChanged,
+    connect(m_pDomainNameLineEdit, &QILineEdit::textChanged,
             this, &UIHostnameDomainNameEditor::sltDomainChanged);
 
@@ -155,12 +155,12 @@
     m_pHostnameLineEdit->mark(!m_pHostnameLineEdit->hasAcceptableInput(),
                               tr("Hostname should be a string of length 2. Allowed characters are alphanumerics, '-', and '.'" ));
-    emit sigHostnameDomainChanged(hostnameDomain());
+    emit sigHostnameDomainNameChanged(hostnameDomainName());
 }
 
 void UIHostnameDomainNameEditor::sltDomainChanged()
 {
-    m_pDomainLineEdit->mark(!m_pDomainLineEdit->hasAcceptableInput(),
+    m_pDomainNameLineEdit->mark(!m_pDomainNameLineEdit->hasAcceptableInput(),
                               tr("Domain name should be a string of length 2. Allowed characters are alphanumerics, '-', and '.'" ));
 
-    emit sigHostnameDomainChanged(hostnameDomain());
+    emit sigHostnameDomainNameChanged(hostnameDomainName());
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.h	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.h	(revision 90157)
@@ -42,5 +42,5 @@
 signals:
 
-    void sigHostnameDomainChanged(const QString &strHostNameDomain);
+    void sigHostnameDomainNameChanged(const QString &strHostNameDomain);
 
 public:
@@ -51,8 +51,8 @@
     void setHostname(const QString &strHostname);
 
-    QString domain() const;
-    void setDomain(const QString &strDomain);
+    QString domainName() const;
+    void setDomainName(const QString &strDomain);
 
-    QString hostnameDomain() const;
+    QString hostnameDomainName() const;
 
     bool isComplete() const;
@@ -73,8 +73,8 @@
 
     QILineEdit  *m_pHostnameLineEdit;
-    QILineEdit  *m_pDomainLineEdit;
+    QILineEdit  *m_pDomainNameLineEdit;
 
     QLabel *m_pHostnameLabel;
-    QLabel *m_pDomainLabel;
+    QLabel *m_pDomainNameLabel;
 
 };
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 90157)
@@ -742,12 +742,12 @@
 }
 
-const QString &UIWizardNewVM::hostnameDomain() const
-{
-    return m_unattendedInstallData.m_strHostnameDomain;
-}
-
-void UIWizardNewVM::setHostnameDomain(const QString &strHostnameDomain)
-{
-    m_unattendedInstallData.m_strHostnameDomain = strHostnameDomain;
+const QString &UIWizardNewVM::hostnameDomainName() const
+{
+    return m_unattendedInstallData.m_strHostnameDomainName;
+}
+
+void UIWizardNewVM::setHostnameDomainName(const QString &strHostnameDomain)
+{
+    m_unattendedInstallData.m_strHostnameDomainName = strHostnameDomain;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h	(revision 90157)
@@ -52,5 +52,5 @@
     QString m_strUserName;
     QString m_strPassword;
-    QString m_strHostnameDomain;
+    QString m_strHostnameDomainName;
     QString m_strProductKey;
     bool m_fInstallGuestAdditions;
@@ -134,6 +134,6 @@
     void setGuestAdditionsISOPath(const QString &strGAISOPath);
 
-    const QString &hostnameDomain() const;
-    void setHostnameDomain(const QString &strHostname);
+    const QString &hostnameDomainName() const;
+    void setHostnameDomainName(const QString &strHostnameDomainName);
 
     const QString &productKey() const;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90157)
@@ -102,6 +102,6 @@
                 this, &UIWizardNewVMUnattendedPageBasic::sltInstallGACheckBoxToggle);
     if (m_pHostnameDomainNameEditor)
-        connect(m_pHostnameDomainNameEditor, &UIHostnameDomainNameEditor::sigHostnameDomainChanged,
-                this, &UIWizardNewVMUnattendedPageBasic::sltHostnameDomainChanged);
+        connect(m_pHostnameDomainNameEditor, &UIHostnameDomainNameEditor::sigHostnameDomainNameChanged,
+                this, &UIWizardNewVMUnattendedPageBasic::sltHostnameDomainNameChanged);
     if (m_pProductKeyLineEdit)
         connect(m_pProductKeyLineEdit, &QLineEdit::textChanged,
@@ -167,10 +167,10 @@
         m_pHostnameDomainNameEditor->blockSignals(true);
 
-        if (!m_userModifiedParameters.contains("HostnameDomain"))
+        if (!m_userModifiedParameters.contains("HostnameDomainName"))
         {
             m_pHostnameDomainNameEditor->setHostname(pWizard->machineBaseName());
-            m_pHostnameDomainNameEditor->setDomain("myguest.virtualbox.org");
+            m_pHostnameDomainNameEditor->setDomainName("myguest.virtualbox.org");
             /* Initialize unattended hostname here since we cannot get the efault value from CUnattended this early (unlike username etc): */
-            newVMWizardPropertySet(HostnameDomain, m_pHostnameDomainNameEditor->hostnameDomain());
+            newVMWizardPropertySet(HostnameDomainName, m_pHostnameDomainNameEditor->hostnameDomainName());
         }
 
@@ -252,8 +252,8 @@
 }
 
-void UIWizardNewVMUnattendedPageBasic::sltHostnameDomainChanged(const QString &strHostnameDomain)
-{
-    newVMWizardPropertySet(HostnameDomain, strHostnameDomain);
-    m_userModifiedParameters << "HostnameDomain";
+void UIWizardNewVMUnattendedPageBasic::sltHostnameDomainNameChanged(const QString &strHostnameDomainName)
+{
+    newVMWizardPropertySet(HostnameDomainName, strHostnameDomainName);
+    m_userModifiedParameters << "HostnameDomainName";
     emit completeChanged();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h	(revision 90156)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h	(revision 90157)
@@ -65,5 +65,5 @@
     void sltPasswordChanged(const QString &strPassword);
     void sltUserNameChanged(const QString &strUserName);
-    void sltHostnameDomainChanged(const QString &strHostname);
+    void sltHostnameDomainNameChanged(const QString &strHostnameDomainName);
     void sltProductKeyChanged(const QString &strProductKey);
     void sltStartHeadlessChanged(bool fStartHeadless);