Index: trunk/src/VBox/Frontends/VBoxManage/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/Makefile.kmk	(revision 90213)
+++ trunk/src/VBox/Frontends/VBoxManage/Makefile.kmk	(revision 90214)
@@ -105,4 +105,5 @@
  	$(if $(VBOX_WITH_NAT_SERVICE),../../NetworkServices/NetLib/VBoxNetPortForwardString.cpp,) \
  	VBoxManageCloud.cpp \
+ 	VBoxManageCloudMachine.cpp \
  	../Common/PasswordInput.cpp
  VBoxManage_SOURCES.win = \
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp	(revision 90213)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp	(revision 90214)
@@ -41,4 +41,13 @@
 
 using namespace com;//at least for Bstr
+
+
+/*
+ * "cloud machine" handling is in VBoxManageCloudMachine.cpp to make
+ * this file less crowded.
+ */
+RTEXITCODE handleCloudMachine(HandlerArg *a, int iFirst, const ComPtr<ICloudProfile> &pCloudProfile);
+RTEXITCODE listCloudMachines(HandlerArg *a, int iFirst, const ComPtr<ICloudProfile> &pCloudProfile);
+
 
 /**
@@ -453,5 +462,6 @@
         { "objects",             1005, RTGETOPT_REQ_NOTHING },
         { "help",                1006, RTGETOPT_REQ_NOTHING },
-        { "--help",              1007, RTGETOPT_REQ_NOTHING }
+        { "--help",              1007, RTGETOPT_REQ_NOTHING },
+        { "machines",            1008, RTGETOPT_REQ_NOTHING }
     };
 
@@ -476,4 +486,9 @@
                 printHelp(g_pStdOut);
                 return RTEXITCODE_SUCCESS;
+
+            case 1008:          /* machines */
+                return listCloudMachines(a, GetState.iNext,
+                                         pCommonOpts->profile.pCloudProfile);
+
             case VINF_GETOPT_NOT_OPTION:
                 return errorUnknownSubcommand(ValueUnion.psz);
@@ -2748,5 +2763,6 @@
         { "network",          1003, RTGETOPT_REQ_NOTHING },
         { "volume",           1004, RTGETOPT_REQ_NOTHING },
-        { "object",           1005, RTGETOPT_REQ_NOTHING }
+        { "object",           1005, RTGETOPT_REQ_NOTHING },
+        { "machine",          1006, RTGETOPT_REQ_NOTHING }
     };
 
@@ -2779,4 +2795,8 @@
                 return handleCloudNetwork(a, GetState.iNext, &commonOpts);
 #endif /* VBOX_WITH_CLOUD_NET */
+            case 1006:
+                return handleCloudMachine(a, GetState.iNext,
+                                          commonOpts.profile.pCloudProfile);
+
             case VINF_GETOPT_NOT_OPTION:
                 return errorUnknownSubcommand(ValueUnion.psz);
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloudMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloudMachine.cpp	(revision 90214)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloudMachine.cpp	(revision 90214)
@@ -0,0 +1,57 @@
+/* $Id$ */
+/** @file
+ * VBoxManageCloudMachine - The cloud machine related commands.
+ */
+
+/*
+ * Copyright (C) 2006-2021 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#include "VBoxManage.h"
+
+#include <VBox/log.h>
+
+#include <VBox/com/ErrorInfo.h>
+#include <VBox/com/Guid.h>
+#include <VBox/com/errorprint.h>
+
+
+/*
+ * VBoxManage cloud machine ...
+ *
+ * The "cloud" prefix handling is in VBoxManageCloud.cpp, so this
+ * function is not static.
+ */
+RTEXITCODE handleCloudMachine(HandlerArg *a, int iFirst,
+                              const ComPtr<ICloudProfile> &pCloudProfile)
+{
+    RT_NOREF(a, iFirst, pCloudProfile);
+
+    return RTMsgErrorExit(RTEXITCODE_FAILURE,
+               "cloud machine - not yet implemented");
+}
+
+
+/*
+ * VBoxManage cloud list machines
+ * VBoxManage cloud machine list
+ *
+ * The "cloud list" prefix handling is in VBoxManageCloud.cpp, so this
+ * function is not static.
+ */
+RTEXITCODE listCloudMachines(HandlerArg *a, int iFirst,
+                             const ComPtr<ICloudProfile> &pCloudProfile)
+{
+    RT_NOREF(a, iFirst, pCloudProfile);
+
+    return RTMsgErrorExit(RTEXITCODE_FAILURE,
+               "cloud list machines - not yet implemented");
+}